#ifndef __AMS_INCLUDED__
#define __AMS_INCLUDED__

#include <stdio.h>
#include <stdlib.h>
//#include "global.h"
#include "namelist.h"
#include "global.h"
#include "amsstruc.h"

#include "dskimgs.h"

//typedef struct CPC_DIRLIST_ENTRY
//{
//	char	Filename[12];
//	int		FileSize;
//} CPC_DIRLIST_ENTRY;


typedef struct
{
		unsigned char	User;
		unsigned char	Filename[8];
		unsigned char	Extension[3];
		unsigned char	FileFlags;
} CPC_FILENAME;


typedef struct
{
        const char    *pFormatName;
        const XDPB    *pFormatXdpb;
        const FORMAT_DATA *pFormatData;
} FORMAT_INFO;

#define SYSTEM		0x0001
#define READ_ONLY	0x0002

typedef struct
{
	char	Filename[13];
	int	FileProtection;
} FILELIST_NODE;


typedef struct
{
	DRIVE_DATA *pDriveData;


	const XDPB	*Xdpb;
	int    XDPBSectorSize;                 /* Size of sector in bytes */
	int    XDPBSectorsPerBlock;            /* Num Sectors per block */
	int		RecordsPerBlock;				/* Size of block /128 */
	int    XDPBBlockSize;                  /* Size of block in bytes */
	int    XDPBNumDirBlocks;               /* Num blocks used by directory */
	int    XDPBTotalBlocks;                /* Total number of blocks on disc */
	int    XDPBNumDirEntries;              /* Number of directory entries -1 */

   char    *pBlockBitmap;                  /* pointer to block bitmap
                                           showing allocation of blocks */
   int     BlockBitmapSize;                /* Size of block bitmap */


	char   *pCPCDirectory;                 /* Pointer to directory */
	int     CPCDirectorySize;               /* Size of buffer for Directory */


	/*char		*pBlock;*/

	/*int     *pBlockList;*/            /* Holds list of blocks used by file */
	/*int     BlockListSize;*/          /* Size of list */
} AMS_FILESYSTEM_DATA;

typedef struct
{
	AMS_FILESYSTEM_DATA	*pFileSystem;
	char	AmsFilename[16];

	int	Drive;

	int		TotalBytes;

	int		*pBlockList;
	int		BlockListSize;
	int		BlockPosition;
	int		BlockBytePosition;
	char		*pBlock;
	int		CurrentBlock;
	AMSDOSDIRENTRY	*pDirEntry;				/* pointer to current dir entry for writing */

	int		DirIndex;

	char	*pDiskImage;
} AMS_FILESYSTEM_FILEHANDLE_DATA;


void			Ams_OpenFile(CPC_FILEHANDLE *,char *,int);
void			Ams_CloseFile(CPC_FILEHANDLE *);

void			Ams_PutChar(CPC_FILEHANDLE *,int);
int				Ams_GetChar(CPC_FILEHANDLE *);
int				Ams_GetFileSize(CPC_FILEHANDLE *pCPCFileHandle);


/* initialise drive */
void			Ams_InitialiseDrive(DRIVE_DATA *pDriveData);
/* free drive */
void			Ams_FreeDrive(DRIVE_DATA *pDriveData);


/* generate a checksum for a amsdos header */
int		GenerateChecksumForAmsdosHeader(AMSDOSFILEHEADER *pHeader);

/* delete a file */
void			Ams_DeleteFile(AMS_FILESYSTEM_DATA *pFileSystem, int UserNo,char *Filename);

/* rename a file */
void			Ams_RenameFile(AMS_FILESYSTEM_DATA *pFileSystem, int UserNo,char *pNewFilename, char *pOldFilename);

/* return TRUE if file will fit on media else FALSE */
BOOL	Ams_FileFit(DRIVE_DATA *pDriveData,int FileSize);

//void    GetAmsFilename(char *Filename,AMSDOSDIRENTRY *pCPCDirectoryEntry);

void	Ams_GenerateFileList(AMS_FILESYSTEM_DATA *pFileSystem, char *FileSpec, NAME_LIST_HEADER *pList);


const FORMAT_INFO *GetFormatsRecognised();

const int GetNumFormatsRecognised();



#endif
