#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "amsdos.h"
#include "globdef.h"
#include "global.h"
#include "filen.h"

extern DRIVE_DATA DriveData[2];
/*============================================================================*/
/* given a CPM Filename (see amsstruc.h) return a structure with details about
it */

void	ParseFilename(char *pFilename, CPM_FILENAME *pCpmFilename)
{
	char	ch;
	char SourceFilename[18];
	int UserNo = -1;
	int DriveNo = -1;
	int index;
	char	CPCFilename[16];

	int FilenameLength = strlen(pFilename);

	if (FilenameLength==0)
		return;

	/* setup source filename so that it has a null at start and beginning */
	SourceFilename[0] = '\0';
	memcpy(&SourceFilename[1],pFilename,FilenameLength);

	/* strip off filename */

	/* search backwards until either '\0' or ':' found */

	/* pointer at end of filename specified */
	index = FilenameLength-1;

	ch = pFilename[index];

	while ((ch!=':') && (ch!='\0'))
	{
		index --;

		ch = pFilename[index];
	}

	/* copy filename */

	HostFilenameToCPCFilename(&pFilename[index],CPCFilename);

	strncpy(pCpmFilename->Filename,CPCFilename,16);

	if (ch==':')
	{
		/* filename and drive, or filename and drive and user specified */

		int multiplier = 1;

		index--;

		ch = pFilename[index];

		if (isdigit(ch))
		{
			UserNo = 0;

			/* get user if present */
			while (isdigit(ch))
			{
				/* convert char into digit */
				UserNo = UserNo + ((ch-'0')*multiplier);

				multiplier=multiplier*10;

				index--;

				ch = pFilename[index];
			}
		}

		DriveNo = (ch-'A');
	}

	pCpmFilename->Drive = DriveNo;
	pCpmFilename->User = UserNo;
}
