#ifndef __AMS_STRUCTS_INCLUDED__
#define __AMS_STRUCTS_INCLUDED__

/* Amstrad related structures */

/* CPC Amsdos file header */
typedef struct
{
        unsigned char   User;
        unsigned char   Filename[8];
        unsigned char   Extension[3];
        unsigned char   pad0[6];
        unsigned char   FileType;
        unsigned char   DataLengthLow;
        unsigned char   DataLengthHigh;
        unsigned char   DataLocationLow;
        unsigned char   DaraLocationHigh;
        unsigned char   pad1[1];
        unsigned char   FileLengthLow;
        unsigned char   FileLengthHigh;
        unsigned char   EntryAddressLow;
        unsigned char   EntryAddressHigh;
        unsigned char   pad2[64-28];
        unsigned char   TotalFileLengthLow;
        unsigned char   TotalFileLengthMid;
        unsigned char   TotalFileLengthHigh;
        unsigned char   ChecksumLow;
        unsigned char   ChecksumHigh;
        unsigned char   pad3[128-69];
} AMSDOSFILEHEADER;

/* CPC Directory Entry */
typedef struct
{
        unsigned char   User;                   /* User number of file */
        unsigned char   Filename[8];            /* Filename part */
        unsigned char   Extension[3];           /* Extension part */
        unsigned char   DirEntryNum;            /* Dir Entry Num */
        unsigned char   pad[2];                 /* Not used */
        unsigned char   Records;                /* Records (128 byte entries used
                                           by the blocks in this dir entry
                                         */
        unsigned char   Blocks[16];             /* Clusters file occupies */
} AMSDOSDIRENTRY;

/* eXpanded Disc Parameter Block - defines disc format */
typedef struct
{
        unsigned char   RecordsPerTrackLow;
        unsigned char   RecordsPerTrackHigh;
        unsigned char   BlockSizeN;
        unsigned char   RecordsPerBlock;        /* 128 byte records per track */
        unsigned char   BlockSizeK;
        unsigned char   TotalBlocksLow;         /* Total Blocks on Disc -1 */
        unsigned char   TotalBlocksHigh;
        unsigned char   NumDirEntriesLow;  /* Number of Directory entries -1 */
        unsigned char   NumDirEntriesHigh;
        unsigned char   DirAllocBitMapLow;
        unsigned char   DirAllocBitMapHigh;
        unsigned char   DirChecksumLow;
        unsigned char   DirChecksumHigh;
        unsigned char   DirTrackLow;
        unsigned char   DirTrackHigh;
        unsigned char   FirstSectorNum;
        unsigned char   SectorsPerTrack;
        unsigned char   GapLengthRead;
        unsigned char   GapLengthFormat;
        unsigned char   FillerByte;
        unsigned char   SectorSizeN;
        unsigned char   RecordsPerSector;
        unsigned char   ReservedCurrentTrack;
        unsigned char   ReservedAlignment;
        unsigned char   ReservedSelectFormat;
} XDPB;

/* structure returned after parsing a CPM Style filename spec

  [<drive>[<user>] : ] <filename> . <ext>
*/

typedef struct
{
	int		Drive;			/* drive (0,1 ..) or -1 if not specified */
	int		User;			/* user (0..15) or -1 if not specified */
	char	Filename[12];	/* filename in 8.3 format */
} CPM_FILENAME;


#endif
