/* My CLI */

#include <stdio.h>
#include <conio.h>
#include "cli.h"

#include "winconsole.h"

static int ColumnPos, RowPos;

#define CLI_BUFFER_SIZE	256
static char CLI_Buffer[CLI_BUFFER_SIZE];

static int MaxColumn=25;
static int MaxRow=80;

static int StartColumn;
static int StartRow;

static int CLI_Buffer_Pos;

void	CLI_SetTitle(char *Title)
{
	WinConsole_SetConsoleTitle(Title);
}

void	CLI_Clear()
{
	ColumnPos = 0;
	RowPos = 0;

	WinConsole_SetCursorPosition(ColumnPos, RowPos);

	WinConsole_Clear();
}

void	CLI_GoBackChar()
{
	/* go back a char */
	ColumnPos--;

	if (ColumnPos<0)
	{
		ColumnPos = MaxColumn-1;
		RowPos--;

		if (RowPos<0)
		{
			RowPos = MaxRow-1;
		}
	}

	WinConsole_SetCursorPosition(ColumnPos, RowPos);
}

void	CLI_GoForwardChar()
{
	/* go forwards a char */
	ColumnPos++;

	if (ColumnPos>=MaxColumn)
	{
		ColumnPos = 0;
		RowPos++;

		if (RowPos>=MaxRow)
		{
			RowPos = 0;
		}
	}

	WinConsole_SetCursorPosition(ColumnPos, RowPos);
}

void	CLI_ProcessChar(unsigned char ch)
{
	/* delete char */
	if (ch==8)
	{
		CLI_GoBackChar();
		return;
	}

	if ((ch<32) || (ch>127))
	{
		/* control char or UDG */

		CLI_GoBackChar();
		return;
	}


	if (ch!=13)
	{
		if (CLI_Buffer_Pos!=CLI_BUFFER_SIZE-1)
		{
			CLI_Buffer[CLI_Buffer_Pos] = ch;
			CLI_Buffer_Pos++;

			WinConsole_WriteChar(ch);

			CLI_GoForwardChar();


		}
	}
}

void	CLI_GetInput()
{
	char	ch=0;

	StartColumn = ColumnPos;
	StartRow = RowPos;

	/* initialise to start of buffer */
	CLI_Buffer_Pos = 0;

	/* loop until return pressed */
	do
	{
		/* is key pressed? */
		if (_kbhit()!=0)
		{
			/* get key */
			ch = _getch();

			/* process character */
			CLI_ProcessChar(ch);
		}
	}
	while (ch!=13);

	/* mark end of CLI data entered */
	CLI_Buffer[CLI_Buffer_Pos] = '\0';
}


void	CLI_Go()
{
	WinConsole_Initialise();

	MaxColumn = WinConsole_GetConsoleWidth();
	MaxRow = WinConsole_GetConsoleHeight();


	CLI_SetTitle("FILEXFER");
	CLI_Clear();

	CLI_GetInput();
}
