/****-**************************************************************************/
/* This module handles converting filenames between CPC and host filesystems  */
/* Long filenames are supported.                                              */
/******************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* defines valid chars allowed in CPC filenames */

#define CPC_VALID(x)	(((x>='0') && (x<='9')) || ((x>='A') && (x<='Z')) \
	|| (x=='!') || (x=='"') || (x=='#') || (x=='$') || (x=='&') \
	|| /*(x==''') ||*/ (x=='+') || (x=='-') || (x=='@') || (x=='^') \
	|| (x=='`') || (x=='{') || (x=='}') || (x=='~') || (x=='.')) 

/* defines valid chars allowed in HOST filenames */
/*#define HOST_VALID*/

void	CPCFilenameToHostFilename(char	*CPCFilename,char *HostFilename)
{
int	i,j;
int CPCFilenameLen = strlen(CPCFilename);

	for (i=0; i<CPCFilenameLen; i++)
	{
		CPCFilename[i] = tolower(CPCFilename[i]);
	}
	
	j=0;
	
	/* strip out the spaces and convert invalid chars
	to an equivalent allowed by host */
	
	for (i=0; i<CPCFilenameLen; i++)
	{
		if (CPCFilename[i]!=' ')
		{
				HostFilename[j] = CPCFilename[i];
				j++;
		}
	}
	
	/* if last char of filename is '.' then filename has no extension,
	   so remove the '.' */
	   
	if (HostFilename[j-1]=='.')
	{
		j--;
	}

	HostFilename[j]='\0';

	#ifdef DEBUG		
	printf("CPC: ->%s<- Host: ->%s<-\n",CPCFilename,HostFilename);
	#endif
}


void	HostFilenameToCPCFilename(char *HostFilename, char *CPCFilename)
{
int i,j;
int ch;
char	TempCPCFilename[256];
int	FilenameLength;
int HostFilenameLen = strlen(HostFilename);

	/* setup dest filename */

	memset(CPCFilename,' ',12);
	CPCFilename[8]='.';
	CPCFilename[12]='\0';
	
	/* convert to upper case */

	for (i=0; i<HostFilenameLen; i++)
	{
		HostFilename[i] = toupper(HostFilename[i]);
	}

	printf("HostFilename: %s\n",HostFilename);
	
	/* remove invalid chars */
	j=0;
		
	for (i=0; i<HostFilenameLen; i++)
	{
		ch=HostFilename[i];
		
		/* check if char can be converted to a similar one for CPC*/
		
		/* strip out bad chars */
		
		if (CPC_VALID(ch))
		{
						TempCPCFilename[j] = HostFilename[i];
						j++;
		}
	}

	TempCPCFilename[j]='\0';

	j=0;
	i=0;	
	do
	{
		ch = TempCPCFilename[i];
		i++;
		
		if ((ch!='\0') && (ch!='.') && (j<8))
		{
			CPCFilename[j] = ch;
			j++;
		}
	}	
	while ((ch!='\0') && (ch!='.') && (j<8));
	
	FilenameLength = strlen(TempCPCFilename);
	
	for (i=0; i<FilenameLength; i++)
	{
			if (TempCPCFilename[FilenameLength-i]=='.')
			{
				break;
			}
	}
	
	if (FilenameLength-i!=0)
	{
		i=FilenameLength-i+1;
		j=0;
		do
		{
				ch = TempCPCFilename[i];
				i++;
				
				if ((ch!='\0') && (j<3))
				{
				
					CPCFilename[9+j] = ch;
					j++;
				}
		}		
		while ((ch!='\0') && (j<3));
	}		
		

	if (CPCFilename[0]==' ')
	{
		CPCFilename[0]='!';
	}
	
	
	printf("Output: ->%s<-\n",CPCFilename);
	
	if (j>11)
	{
		printf("Bad filename - length exceeds maximum allowed");
	}
}
