#ifndef __FILEXFER_HEADER_INCLUDED__
#define __FILEXFER_HEADER_INCLUDED__

#include <stdio.h>
#include <stdlib.h>
#include "global.h"

#include "namelist.h"

typedef struct SECTOR_POS
{
    int Drive;
    unsigned char   Track;		/* physical track */
    unsigned char   Side;		/* physical side */

    unsigned char   C;
    unsigned char   H;
    unsigned char   R;
    unsigned char   N;
    //unsigned char   Sector;		/* sector id */
} SECTOR_POS;

/* Drive operations */

void	FileXfer_InitialiseDrive(int,int,void *);
void	FileXfer_FreeDrive(int);

/* File stuff */

CPC_FILEHANDLE	*FileXfer_OpenFile(int,char *,int);
int	FileXfer_GetChar(CPC_FILEHANDLE *);
void	FileXfer_PutChar(CPC_FILEHANDLE *,int);
void	FileXfer_CloseFile(CPC_FILEHANDLE *);
int	FileXfer_GetFileSize(CPC_FILEHANDLE *);

BOOL		FileXfer_FileFit(int DriveNum, int FileSize);

BOOL    FileXFer_WriteSector(int DriveNum, SECTOR_POS *pSectorPos, char *pData, int Length);
BOOL    FileXFer_ReadSector(int DriveNum, SECTOR_POS *pSectorPos, char *pData, int Length);

/* generate a list of files that match a specific wildcard string on the drive specified */
void	FileXfer_GenerateFileList(int Drive, char *WildCard, NAME_LIST_HEADER *pNameListHeader);

/* perform a directory of the selected drive */
void	FileXfer_Directory(int Drive);

/* copy multiple files between source and destination drives */
void	FileXfer_CopyMultiple(int SourceDrive, int DestDrive, char *WildCard);

/* copy a single file between source and destination drives */
void	FileXfer_CopySingle(int SourceDrive, int DestDrive, char *SourceFilename);

/* convert a file between filesystems */
void	ConvertFilename(int SourceDrive, int DestDrive, char *pSourceFilename, char *pDestFilename);

int	FileXfer_GetSizeOfNamedFile(int Drive, char *pFilename);


#endif
