#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "wildcard.h"

/*============================================================================*/
/* AMSDOS style wild-card handling - basic version */

/* convert a wildcard into a 8.3 representation. */
/* '*' chars are replaced with necessary number of '?' chars */

void WildCard_Parse(char *pWildString, char *pProcessed)
{
//	int		WildStringLen = strlen(pWildString);
	char	ch;
	int	count = 0;
	int	i=0;

	// setup output string
	memset(pProcessed,'?',12);
	pProcessed[8]='.';
	pProcessed[12]='\0';

	do
	{
		ch = pWildString[i];
		i++;

		if (ch=='\0')
		{
			/* end of source string reached */
			if (count<8)
			{
				/* haven't got as far as a extension */

				/* therefore extension must be "   " */
				pProcessed[9]=' ';
				pProcessed[10]=' ';
				pProcessed[11]=' ';
			}

			break;
		}

		if (ch!='*')
		{
			if (ch!='.')
			{
				pProcessed[count] = toupper(ch);
				count++;
			}
			else
			{
				count = 9;
			}
		}
		else
		{
			if (count>=9)
				break;

			if (count<8)
			{
				count = 9;
			}
		}
	}
	while (ch!='\0');
}

/* taken a parsed wild card, and a given filename return
TRUE if filename is selected by wildcard else FALSE.

  - Filename and wildcard must both be 8.3 format.

  - wildcard must be pre-parsed
*/

BOOL	WildCard_Match(char *pFilename, char *pWild)
{
	int LenFilename = strlen(pFilename);

	int	i;

	for (i=0; i<LenFilename; i++)
	{
		if (pWild[i]!='?')
		{
			if (pFilename[i]!=pWild[i])
				return FALSE;
		}
	}

	return TRUE;
}



